diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/RankTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/RankTest.java
index 14a2cb9713..a78f8d5d5a 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/RankTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/RankTest.java
@@ -9,13 +9,15 @@
  
 package eu.etaxonomy.cdm.model.name;
 
-import static org.junit.Assert.*;
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertTrue;
+import static org.junit.Assert.fail;
 
 import java.util.UUID;
 
 import org.apache.log4j.Logger;
 import org.junit.BeforeClass;
-import org.junit.Ignore;
 import org.junit.Test;
 
 import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
@@ -76,6 +78,11 @@ public class RankTest extends EntityTestBase {
 	private static final UUID uuidPathoVariety = UUID.fromString("2f4f4303-a099-47e3-9048-d749d735423b");
 	private static final UUID uuidSubvariety = UUID.fromString("9a83862a-7aee-480c-a98d-4bceaf8712ca");
 	private static final UUID uuidSubsubvariety = UUID.fromString("bff22f84-553a-4429-a4e7-c4b3796c3a18");
+	
+	private static final UUID uuidProles = UUID.fromString("8810d1ba-6a34-4ae3-a355-919ccd1cd1a5");
+	private static final UUID uuidRace = UUID.fromString("196dee39-cfd8-4460-8bf0-88b83da27f62");
+	private static final UUID uuidSublusus = UUID.fromString("1fafa596-a8e7-4e62-a378-3cc8cb3627ca");
+	
 	private static final UUID uuidConvar = UUID.fromString("2cc740c9-cebb-43c8-9b06-1bef79e6a56a");
 	private static final UUID uuidForm = UUID.fromString("0461281e-458a-47b9-8d41-19a3d39356d5");
 	private static final UUID uuidSpecialForm = UUID.fromString("bed20aee-2f5a-4635-9c02-eff06246d067");
@@ -94,22 +101,17 @@ public class RankTest extends EntityTestBase {
 		DefaultTermInitializer vocabularyStore = new DefaultTermInitializer();
 		vocabularyStore.initialize();
 	}
-	
-	@Test
-	public void testRank() {
-		Rank rank = new Rank();
-		assertNotNull(rank);
-	}
 
 	@Test
 	public void testRankStringString() {
-		Rank rank = new Rank("term", "label", null);
+		Rank rank = new Rank(RankClass.Species, "term", "label", null);
 		assertEquals("label", rank.getLabel());
 	}
 	
 	@Test
 	public void testEMPIRE() {
 		assertEquals(uuidEmpire,  Rank.EMPIRE().getUuid());
+		assertTrue(Rank.EMPIRE().isSupraGeneric());
 	}
 
 	@Test
@@ -361,9 +363,25 @@ public class RankTest extends EntityTestBase {
 		assertEquals(uuidSubsubvariety,  Rank.SUBSUBVARIETY().getUuid());	
 	}
 
+	@Test
+	public void testPROLES() {
+		assertEquals(uuidProles,  Rank.PROLES().getUuid());	
+	}
+	
+	@Test
+	public void testRACE() {
+		assertEquals(uuidRace,  Rank.RACE().getUuid());	
+	}
+	
+	@Test
+	public void testSUBLUSUS() {
+		assertEquals(uuidSublusus,  Rank.SUBLUSUS().getUuid());	
+	}
+	
 	@Test
 	public void testCONVAR() {
-		assertEquals(uuidConvar,  Rank.CONVAR().getUuid());	}
+		assertEquals(uuidConvar,  Rank.CONVAR().getUuid());	
+	}
 
 	@Test
 	public void testFORM() {
@@ -500,18 +518,18 @@ public class RankTest extends EntityTestBase {
 
 	@Test
 	public void testGetRankByNameOrAbbreviation() {
-		NomenclaturalCode bot = NomenclaturalCode.ICBN;
+		NomenclaturalCode bot = NomenclaturalCode.ICNAFP;
 		NomenclaturalCode zoo = NomenclaturalCode.ICZN;
 		try {
-			assertEquals(Rank.VARIETY(), Rank.getRankByAbbreviation("var."));
+			assertEquals(Rank.VARIETY(), Rank.getRankByIdInVoc("var."));
 			assertEquals(Rank.GENUS(), Rank.getRankByName("genus"));
 			
-			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByAbbreviation("sect."));
-			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByAbbreviation("sect.", false));
-			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByAbbreviation("sect.", bot));
-			assertEquals(Rank.SECTION_ZOOLOGY(), Rank.getRankByAbbreviation("sect.", zoo));
-			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByAbbreviation("sect.", bot, false));
-			assertEquals(Rank.SECTION_ZOOLOGY(), Rank.getRankByAbbreviation("sect.", zoo, false));
+			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByIdInVoc("sect."));
+			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByIdInVoc("sect.", false));
+			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByIdInVoc("sect.", bot));
+			assertEquals(Rank.SECTION_ZOOLOGY(), Rank.getRankByIdInVoc("sect.", zoo));
+			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByIdInVoc("sect.", bot, false));
+			assertEquals(Rank.SECTION_ZOOLOGY(), Rank.getRankByIdInVoc("sect.", zoo, false));
 			
 			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByName("Sectio"));
 			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByName("Sectio", false));
@@ -520,14 +538,14 @@ public class RankTest extends EntityTestBase {
 			assertEquals(Rank.SECTION_BOTANY(), Rank.getRankByName("Sectio", bot, false));
 			assertEquals(Rank.SECTION_ZOOLOGY(), Rank.getRankByName("Sectio", zoo, false));
 			
-			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrAbbreviation("Subsectio"));
-			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrAbbreviation("subsect."));
-			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrAbbreviation("Subsectio", false));
-			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrAbbreviation("subsect.", false));
-			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrAbbreviation("Subsectio", bot));
-			assertEquals(Rank.SUBSECTION_ZOOLOGY(), Rank.getRankByNameOrAbbreviation("subsect.", zoo));
-			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrAbbreviation("Subsectio", bot, false));
-			assertEquals(Rank.SUBSECTION_ZOOLOGY(), Rank.getRankByNameOrAbbreviation("subsect.", zoo, false));
+			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrIdInVoc("Subsectio"));
+			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrIdInVoc("subsect."));
+			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrIdInVoc("Subsectio", false));
+			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrIdInVoc("subsect.", false));
+			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrIdInVoc("Subsectio", bot));
+			assertEquals(Rank.SUBSECTION_ZOOLOGY(), Rank.getRankByNameOrIdInVoc("subsect.", zoo));
+			assertEquals(Rank.SUBSECTION_BOTANY(), Rank.getRankByNameOrIdInVoc("Subsectio", bot, false));
+			assertEquals(Rank.SUBSECTION_ZOOLOGY(), Rank.getRankByNameOrIdInVoc("subsect.", zoo, false));
 						
 		} catch (UnknownCdmTypeException e) {
 			fail();
@@ -538,7 +556,7 @@ public class RankTest extends EntityTestBase {
 	@Test
 	public void testGetRankByAbbreviation() {
 		try {
-			assertEquals(Rank.SPECIES(), Rank.getRankByAbbreviation("sp."));
+			assertEquals(Rank.SPECIES(), Rank.getRankByIdInVoc("sp."));
 		} catch (UnknownCdmTypeException e) {
 			fail();
 		}
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/SpecimenTypeDesignationTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/SpecimenTypeDesignationTest.java
index ae5ab8d0ff..157c95e35a 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/SpecimenTypeDesignationTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/SpecimenTypeDesignationTest.java
@@ -23,7 +23,7 @@ import org.junit.BeforeClass;
 import org.junit.Test;
 
 import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 
 /**
  * @author a.babadshanjan
@@ -48,7 +48,7 @@ public class SpecimenTypeDesignationTest {
 	public void setUp() {
 		term1 = new SpecimenTypeDesignation();
 		term2 = 
-			new SpecimenTypeDesignation(Specimen.NewInstance(), SpecimenTypeDesignationStatus.ISOTYPE(), 
+			new SpecimenTypeDesignation(DerivedUnit.NewPreservedSpecimenInstance(), SpecimenTypeDesignationStatus.ISOTYPE(), 
 					null, null, null, false);
 	}
 	
@@ -69,9 +69,9 @@ public class SpecimenTypeDesignationTest {
 	
 	@Test
 	public void testBidirectionalRelationship(){
-		term2 = new SpecimenTypeDesignation(Specimen.NewInstance(), SpecimenTypeDesignationStatus.ISOTYPE(), 
+		term2 = new SpecimenTypeDesignation(DerivedUnit.NewPreservedSpecimenInstance(), SpecimenTypeDesignationStatus.ISOTYPE(), 
 				null, null, null, false);
-		Specimen specimen = (Specimen) term2.getTypeSpecimen();
+		DerivedUnit specimen = (DerivedUnit) term2.getTypeSpecimen();
 		Set<SpecimenTypeDesignation> set = specimen.getSpecimenTypeDesignations();
 		boolean contains = false;
 		for (SpecimenTypeDesignation spec: set){
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/TaxonNameBaseTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/TaxonNameBaseTest.java
index 9b05bfb02d..78caf85c56 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/TaxonNameBaseTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/name/TaxonNameBaseTest.java
@@ -9,32 +9,33 @@
 
 package eu.etaxonomy.cdm.model.name;
 
-import java.util.HashSet;
-import java.util.Map;
-import java.util.Set;
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertNotSame;
+import static org.junit.Assert.assertNull;
+import static org.junit.Assert.assertSame;
+import static org.junit.Assert.assertTrue;
 
-import static org.junit.Assert.*;
+import java.util.Map;
 
 import org.apache.log4j.Logger;
 import org.junit.Before;
 import org.junit.BeforeClass;
 import org.junit.Test;
 
-import eu.etaxonomy.cdm.model.agent.Team;
 import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
 import eu.etaxonomy.cdm.model.description.TextData;
 import eu.etaxonomy.cdm.model.media.Media;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
-import eu.etaxonomy.cdm.model.reference.IArticle;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.reference.INomenclaturalReference;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.strategy.cache.name.INameCacheStrategy;
-import eu.etaxonomy.cdm.strategy.cache.reference.ReferenceBaseDefaultCacheStrategy;
 
 /**
  * @author a.mueller
@@ -810,7 +811,7 @@ public class TaxonNameBaseTest {
 		NomenclaturalStatus nomStatus = NomenclaturalStatus.NewInstance(NomenclaturalStatusType.CONSERVED(), statusReference, "55");
 		taxonNameBase1.addStatus(nomStatus);
 		//typeDesignation
-		Specimen typeSpecimen = Specimen.NewInstance();
+		DerivedUnit typeSpecimen = DerivedUnit.NewPreservedSpecimenInstance();
 		Reference<?> specimenTypeCitation = ReferenceFactory.newArticle();
 		Reference<?> nameTypeCitation = ReferenceFactory.newArticle();
 		SpecimenTypeDesignation specimenTypeDesignationOriginal = taxonNameBase1.addSpecimenTypeDesignation(typeSpecimen, SpecimenTypeDesignationStatus.HOLOTYPE(), specimenTypeCitation, null, null, false, false);
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/occurrence/SpecimenTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/occurrence/SpecimenTest.java
index b10ee7608d..9d0fff5002 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/occurrence/SpecimenTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/occurrence/SpecimenTest.java
@@ -30,6 +30,7 @@ import com.ibm.lsid.MalformedLSIDException;
 
 import eu.etaxonomy.cdm.model.agent.Person;
 import eu.etaxonomy.cdm.model.common.Annotation;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.Extension;
 import eu.etaxonomy.cdm.model.common.IdentifiableSource;
 import eu.etaxonomy.cdm.model.common.LSID;
@@ -38,9 +39,7 @@ import eu.etaxonomy.cdm.model.common.LanguageStringBase;
 import eu.etaxonomy.cdm.model.common.Marker;
 import eu.etaxonomy.cdm.model.common.MarkerType;
 import eu.etaxonomy.cdm.model.common.OriginalSourceBase;
-import eu.etaxonomy.cdm.model.description.Sex;
 import eu.etaxonomy.cdm.model.description.SpecimenDescription;
-import eu.etaxonomy.cdm.model.description.Stage;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.media.Rights;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
@@ -51,16 +50,15 @@ import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 /**
  * @author a.mueller
  * @created 28.10.2008
- * @version 1.0
  */
 public class SpecimenTest {
 	private static final Logger logger = Logger.getLogger(SpecimenTest.class);
 
-	private Specimen specimen;
+	private DerivedUnit specimen;
 	
 	@Before
 	public void setUp() throws Exception {
-		specimen = Specimen.NewInstance();
+		specimen = DerivedUnit.NewPreservedSpecimenInstance();
 	}
 
 	/**
@@ -68,18 +66,10 @@ public class SpecimenTest {
 	 */
 	@Test
 	public void testNewInstance() {
-		Specimen specimen = Specimen.NewInstance();
-		assertNotNull(specimen);
-		assertTrue(specimen instanceof Specimen);
-	}
-
-	/**
-	 * Test method for {@link eu.etaxonomy.cdm.model.occurrence.Specimen#Specimen()}.
-	 */
-	@Test
-	public void testSpecimen() {
-		Specimen specimen = new Specimen();
+		DerivedUnit specimen = DerivedUnit.NewPreservedSpecimenInstance();
 		assertNotNull(specimen);
+		assertTrue(specimen instanceof DerivedUnit);
+		assertTrue(specimen.getRecordBasis().equals(SpecimenOrObservationType.PreservedSpecimen));
 	}
 
 	/**
@@ -94,11 +84,89 @@ public class SpecimenTest {
 		specimen.setPreservation(null);
 	}
 	
+	@Test
+	public void testBidirectionalSpecimenDescription(){
+		Assert.assertNotNull("Specimen should exist", specimen);
+		
+		SpecimenDescription desc = SpecimenDescription.NewInstance(specimen);
+		Assert.assertNotNull("Description should exist.", desc);
+		Assert.assertSame("Descriptions specimen should be set correctly", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertTrue("Specimen should contain description", specimen.getDescriptions().contains(desc));
+		
+		SpecimenDescription desc2 = SpecimenDescription.NewInstance();
+		Assert.assertNotNull("Description should exist.", desc2);
+		specimen.addDescription(desc2);
+		Assert.assertSame("Description2 specimen should be set correctly", desc2.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertSame("Descriptions specimen should still be set correctly", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertTrue("Specimen should contain description2", specimen.getDescriptions().contains(desc2));
+		Assert.assertTrue("Specimen should still contain description", specimen.getDescriptions().contains(desc));
+		
+		SpecimenDescription desc3 = SpecimenDescription.NewInstance();
+		Assert.assertNotNull("Description should exist.", desc3);
+		desc3.setDescribedSpecimenOrObservation(specimen);
+		Assert.assertSame("Description3 specimen should be set correctly", desc3.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertSame("Descriptions2 specimen should still be set correctly", desc2.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertSame("Descriptions specimen should still be set correctly", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertTrue("Specimen should contain description3", specimen.getDescriptions().contains(desc3));
+		Assert.assertTrue("Specimen should still contain description2", specimen.getDescriptions().contains(desc2));
+		Assert.assertTrue("Specimen should still contain description", specimen.getDescriptions().contains(desc));
+
+		
+		//change specimen of a given description
+		DerivedUnit specimen2 = DerivedUnit.NewPreservedSpecimenInstance();
+		Assert.assertNotNull("Specimen should exist.", specimen2);
+		desc3.setDescribedSpecimenOrObservation(specimen2);
+		Assert.assertSame("Description3 new specimen should be set correctly", desc3.getDescribedSpecimenOrObservation(),specimen2);
+		Assert.assertSame("Descriptions2 specimen should still be set correctly", desc2.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertSame("Descriptions specimen should still be set correctly", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertTrue("Specimen2 should contain description3", specimen2.getDescriptions().contains(desc3));
+		Assert.assertEquals("Specimen2 should contain exactly 1 description", 1, specimen2.getDescriptions().size());
+		Assert.assertFalse("Specimen should no longer contain description3", specimen.getDescriptions().contains(desc3));
+		Assert.assertTrue("Specimen should still contain description2", specimen.getDescriptions().contains(desc2));
+		Assert.assertTrue("Specimen should still contain description", specimen.getDescriptions().contains(desc));
+
+		//remove description which is not contained
+		specimen.removeDescription(desc3);
+		Assert.assertSame("Nothing should have changed", desc3.getDescribedSpecimenOrObservation(),specimen2);
+		Assert.assertSame("Nothing should have changed", desc2.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertSame("Nothing should have changed", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertTrue("Nothing should have changed", specimen2.getDescriptions().contains(desc3));
+		Assert.assertEquals("Nothing should have changed", 1, specimen2.getDescriptions().size());
+		Assert.assertFalse("Nothing should have changed", specimen.getDescriptions().contains(desc3));
+		Assert.assertTrue("Nothing should have changed", specimen.getDescriptions().contains(desc2));
+		Assert.assertTrue("Nothing should have changed", specimen.getDescriptions().contains(desc));
+		
+		//remove description
+		specimen.removeDescription(desc2);
+		Assert.assertNull("Descriptions2 specimen should not exist anymore", desc2.getDescribedSpecimenOrObservation());
+		Assert.assertSame("Description3 specimen should still be set correctly", desc3.getDescribedSpecimenOrObservation(),specimen2);
+		Assert.assertSame("Descriptions specimen should still be set correctly", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertTrue("Specimen2 should still contain description3", specimen2.getDescriptions().contains(desc3));
+		Assert.assertEquals("Specimen2 should still contain exactly 1 description", 1, specimen2.getDescriptions().size());
+		Assert.assertFalse("Specimen should not contain description2 anymore", specimen.getDescriptions().contains(desc2));
+		Assert.assertFalse("Specimen should still no longer contain description3", specimen.getDescriptions().contains(desc3));
+		Assert.assertTrue("Specimen should still contain description", specimen.getDescriptions().contains(desc));
+
+		//remove description by setting null specimen
+		desc3.setDescribedSpecimenOrObservation(null);
+		Assert.assertNull("Description3 specimen should not exist anymore", desc3.getDescribedSpecimenOrObservation());
+		Assert.assertNull("Descriptions2 specimen should still not exist anymore", desc2.getDescribedSpecimenOrObservation());
+		Assert.assertSame("Descriptions specimen should still be set correctly", desc.getDescribedSpecimenOrObservation(),specimen);
+		Assert.assertFalse("Specimen2 should not contain description3 anymore", specimen2.getDescriptions().contains(desc3));
+		Assert.assertEquals("Specimen2 should contain no description now", 0, specimen2.getDescriptions().size());
+		Assert.assertFalse("Specimen should still no longer contain description2", specimen.getDescriptions().contains(desc2));
+		Assert.assertFalse("Specimen should still no longer contain description3", specimen.getDescriptions().contains(desc3));
+		Assert.assertTrue("Specimen should still contain description", specimen.getDescriptions().contains(desc));
+		
+		
+	}
+
+	
 	@Test
 	public void testBidirectionalTypeDesignation(){
 		SpecimenTypeDesignation desig1 = SpecimenTypeDesignation.NewInstance();
 		SpecimenTypeDesignation desig2 = SpecimenTypeDesignation.NewInstance();
-		Specimen specimen2 = Specimen.NewInstance();
+		DerivedUnit specimen2 = DerivedUnit.NewPreservedSpecimenInstance();
 		
 		specimen.addSpecimenTypeDesignation(desig1);
 		Assert.assertEquals("Specimen1 should be the designations specimen", specimen, desig1.getTypeSpecimen());
@@ -145,7 +213,7 @@ public class SpecimenTest {
 		
 		//Null test is not full implemented, but an error is thrown if null throws 
 		//null pointer exception somewhere
-		Specimen specimenNullClone = (Specimen)specimen.clone();
+		DerivedUnit specimenNullClone = (DerivedUnit)specimen.clone();
 		
 		String accessionNumber = "accNumber";
 		String catalogNumber = "catNumber";
@@ -156,7 +224,7 @@ public class SpecimenTest {
 		DerivationEvent derivedFrom = DerivationEvent.NewInstance(null);
 		int id = 22;
 		int individualCount = 25;
-		Stage lifeStage = Stage.NewInstance();
+		DefinedTerm lifeStage = DefinedTerm.NewStageInstance(null, null, null);
 		LSID lsid = null;
 		try {
 			lsid = new LSID("urn:lsid:example.com:foo:1");
@@ -164,11 +232,11 @@ public class SpecimenTest {
 			// TODO Auto-generated catch block
 			e.printStackTrace();
 		}
-		Specimen nextVersion = Specimen.NewInstance();
-		Specimen previousVersion = Specimen.NewInstance();
+		DerivedUnit nextVersion = DerivedUnit.NewPreservedSpecimenInstance();
+		DerivedUnit previousVersion = DerivedUnit.NewPreservedSpecimenInstance();
 		PreservationMethod preservation = PreservationMethod.NewInstance();
 		boolean protectedTitleCache = true;
-		Sex sex = Sex.FEMALE();
+		DefinedTerm sex = DefinedTerm.SEX_FEMALE();
 		TaxonNameBase<?, ?> storedUnder = BotanicalName.NewInstance(Rank.GENUS());
 		String titleCache = "title";
 		Calendar updated = Calendar.getInstance();
@@ -186,7 +254,7 @@ public class SpecimenTest {
 		Marker marker = Marker.NewInstance(MarkerType.COMPLETE(), false);
 		Rights right = Rights.NewInstance("right", Language.DEFAULT());
 		Media media = Media.NewInstance();
-		IdentifiableSource source = IdentifiableSource.NewInstance("12", "idNamespace");
+		IdentifiableSource source = IdentifiableSource.NewDataImportInstance("12", "idNamespace");
 		
 		specimen.setAccessionNumber(accessionNumber);
 		specimen.setCatalogNumber(catalogNumber);
@@ -214,7 +282,7 @@ public class SpecimenTest {
 		specimen.addDetermination(determination);
 		specimen.addExtension(extension);
 		specimen.addMarker(marker);
-		specimen.addMedia(media);
+//		specimen.addMedia(media);    #3597
 		specimen.addRights(right);
 		specimen.addSource(source);
 
@@ -223,7 +291,7 @@ public class SpecimenTest {
 		} catch (InterruptedException e) {
 			//ignore
 		}
-		Specimen specimenClone = (Specimen)specimen.clone();
+		DerivedUnit specimenClone = (DerivedUnit)specimen.clone();
 		
 		assertFalse(id == specimenClone.getId());
 		assertFalse(created.equals(specimenClone.getCreated()));
@@ -277,7 +345,7 @@ public class SpecimenTest {
 		assertNotSame(marker, specimenClone.getMarkers().iterator().next());
 		assertEquals(1, specimenClone.getMarkers().size());
 		
-		assertEquals(media, specimenClone.getMedia().iterator().next());
+//		assertEquals(media, specimenClone.getMedia().iterator().next());  #3597
 		assertEquals(right, specimenClone.getRights().iterator().next());
 		
 		assertFalse(source.equals(specimenClone.getSources().iterator().next()));
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/ClassificationTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/ClassificationTest.java
index 9d5c673b28..d66b8f1af7 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/ClassificationTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/ClassificationTest.java
@@ -22,6 +22,7 @@ import java.lang.reflect.Method;
 import java.lang.reflect.Modifier;
 import java.util.HashSet;
 import java.util.Iterator;
+import java.util.List;
 import java.util.Set;
 
 import org.junit.Assert;
@@ -132,13 +133,13 @@ public class ClassificationTest {
 	public void testAddRoot() {
 		TaxonNameBase<?,?> synonymName = BotanicalName.NewInstance(Rank.SPECIES());
 		Synonym synonym = Synonym.NewInstance(synonymName, ref1);
-		TaxonNode taxonNode1 = classification1.addChildTaxon(taxon1, null, null, synonym);
-		
+		TaxonNode taxonNode1 = classification1.addChildTaxon(taxon1, null, null);
+		taxonNode1.setSynonymToBeUsed(synonym);
 		
 		
 		
 		//test root node
-		Set<TaxonNode> rootNodes = classification1.getChildNodes();
+		List<TaxonNode> rootNodes = classification1.getChildNodes();
 		assertFalse("List of root nodes should not be empty", rootNodes.isEmpty());
 		assertEquals("Number of root nodes should be 1", 1, rootNodes.size());
 		TaxonNode root = rootNodes.iterator().next();
@@ -149,7 +150,7 @@ public class ClassificationTest {
 		assertEquals(synonym, root.getSynonymToBeUsed());
 		
 		//any node
-		Set<TaxonNode> allNodes = classification1.getChildNodes();
+		List<TaxonNode> allNodes = classification1.getChildNodes();
 		assertFalse("List of root nodes should not be empty", allNodes.isEmpty());
 		assertEquals("Number of root nodes should be 1", 1, allNodes.size());
 		TaxonNode anyNode = allNodes.iterator().next();
@@ -163,7 +164,7 @@ public class ClassificationTest {
 	 */
 	@Test
 	public void testIsTaxonInTree() {
-		classification1.addChildTaxon(taxon1, null, null, null);
+		classification1.addChildTaxon(taxon1, null, null);
 		
 		assertTrue(classification1.isTaxonInTree(taxon1));
 		Taxon anyTaxon = Taxon.NewInstance(null, null);
@@ -176,10 +177,10 @@ public class ClassificationTest {
 	 */
 	@Test
 	public void testMakeRootChildOfOtherNode() {
-		TaxonNode root1 = classification1.addChildTaxon(taxon1, null, null, null);
-		TaxonNode root2 = classification1.addChildTaxon(taxon2, null, null, null);
+		TaxonNode root1 = classification1.addChildTaxon(taxon1, null, null);
+		TaxonNode root2 = classification1.addChildTaxon(taxon2, null, null);
 		Taxon taxon3 = Taxon.NewInstance(null, null);
-		root2.addChildTaxon(taxon3, null, null, null);
+		root2.addChildTaxon(taxon3, null, null);
 		String microRef = "p55";
 		
 		assertFalse("Root1 must not yet be child of root 2", root2.getChildNodes().contains(root1));
@@ -201,7 +202,7 @@ public class ClassificationTest {
 	
 	@Test
 	public void testIsTopmostInTree() {
-		TaxonNode root = classification1.addChildTaxon(taxon1, null, null, null);
+		TaxonNode root = classification1.addChildTaxon(taxon1, null, null);
 		
 		assertTrue(classification1.isTaxonInTree(taxon1));
 		assertTrue(classification1.isTopmostInTree(taxon1));
@@ -209,21 +210,21 @@ public class ClassificationTest {
 		assertFalse(classification1.isTaxonInTree(anyTaxon));
 		assertFalse(classification1.isTopmostInTree(anyTaxon));
 		Taxon child = Taxon.NewInstance(null, null);
-		root.addChildTaxon(child, null, null, null);
+		root.addChildTaxon(child, null, null);
 		assertTrue(classification1.isTaxonInTree(child));
 		assertFalse(classification1.isTopmostInTree(child));
 	}
 	
 	@Test
 	public void testGetTopmostNode() {
-		TaxonNode root = classification1.addChildTaxon(taxon1, null, null, null);
+		TaxonNode root = classification1.addChildTaxon(taxon1, null, null);
 		
 		assertEquals(root, classification1.getTopmostNode(taxon1));
 		Taxon anyTaxon = Taxon.NewInstance(null, null);
 		assertFalse(classification1.isTaxonInTree(anyTaxon));
 		assertNull(classification1.getTopmostNode(anyTaxon));
 		Taxon child = Taxon.NewInstance(null, null);
-		root.addChildTaxon(child, null, null, null);
+		root.addChildTaxon(child, null, null);
 		assertTrue(classification1.isTaxonInTree(child));
 		assertNull(classification1.getTopmostNode(child));
 	}
@@ -233,7 +234,8 @@ public class ClassificationTest {
 
 		TaxonNameBase<?,?> synonymName = BotanicalName.NewInstance(Rank.SPECIES());
 		Synonym synonym = Synonym.NewInstance(synonymName, ref1);
-		TaxonNode rootNode = classification1.addChildTaxon(taxon1, null, null, synonym);
+		TaxonNode rootNode = classification1.addChildTaxon(taxon1, null, null);
+		rootNode.setSynonymToBeUsed(synonym);
 		Assert.assertEquals(0,rootNode.getChildNodes().size());
 		
 		//add child to existing root
@@ -406,17 +408,17 @@ public class ClassificationTest {
 	@Test
 	public void testCloneClassification(){
 		
-		taxonNode1 = classification1.addChildTaxon(taxon1, null, null, null);
+		taxonNode1 = classification1.addChildTaxon(taxon1, null, null);
 		taxonName1.setTitleCache("name1");
 		taxonName12.setTitleCache("name12");
 		taxonName121.setTitleCache("name121");
 		taxonName2.setTitleCache("name2");
 		taxonName3.setTitleCache("name3");
 		
-		taxonNode12 = taxonNode1.addChildTaxon(taxon12, null, null, null);
-		taxonNode121 = taxonNode12.addChildTaxon(taxon121, null, null, null);
-		taxonNode2 = classification1.addChildTaxon(taxon2, null, null, null);
-		taxonNode2.addChildTaxon(taxon3, null, null, null);
+		taxonNode12 = taxonNode1.addChildTaxon(taxon12, null, null);
+		taxonNode121 = taxonNode12.addChildTaxon(taxon121, null, null);
+		taxonNode2 = classification1.addChildTaxon(taxon2, null, null);
+		taxonNode2.addChildTaxon(taxon3, null, null);
 		Classification clone = (Classification)classification1.clone();
 		assertEquals(classification1.getAllNodes().size(), clone.getAllNodes().size());
 		TaxonNode cloneNode = clone.getNode(taxon1);
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/TaxonNodeByNameComparatorTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/TaxonNodeByNameComparatorTest.java
index da43170068..1498c81bf2 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/TaxonNodeByNameComparatorTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/taxon/TaxonNodeByNameComparatorTest.java
@@ -66,10 +66,10 @@ public class TaxonNodeByNameComparatorTest {
         botname_4.setNameCache(nameCache_4, true);
         Taxon taxon_4 = Taxon.NewInstance(botname_4, sec);
 
-        classification.addChildTaxon(taxon_1, sec, null, null);
-        classification.addChildTaxon(taxon_2, sec, null, null);
-        classification.addChildTaxon(taxon_3, sec, null, null);
-        classification.addChildTaxon(taxon_4, sec, null, null);
+        classification.addChildTaxon(taxon_1, sec, null);
+        classification.addChildTaxon(taxon_2, sec, null);
+        classification.addChildTaxon(taxon_3, sec, null);
+        classification.addChildTaxon(taxon_4, sec, null);
 
         classification.getChildNodes();
         ArrayList<TaxonNode> taxonNodes = new ArrayList<TaxonNode>();
